/*
************************************************************
*                         TEST11.C
*                      uCOS EXAMPLE
************************************************************
*/

#include    <STDIO.H>
#include    <STRING.H>
#include    <CTYPE.H>
#include    <STDLIB.H>
#include    <CONIO.H>
#include    <DOS.H>
#include    "UCOS186C.H"
#include    "UCOS.H"
extern void interrupt (*OldTickISR)(void);//rutina de intreruperi 18ms


#define          OS_MAX_TASKS    10 //numar maxim de tak-uri
#define          STK_SIZE      2048 //dimensiunea stivei

#define		 nr_c		3	//nr. cuante pt. autosuspendare


OS_TCB           OSTCBTbl[OS_MAX_TASKS]; //tabela de control a task-urilor
UWORD            OSIdleTaskStk[STK_SIZE];//task fals
UWORD            Stk1[STK_SIZE]; //definire stive task-uri
UWORD            Stk2[STK_SIZE];
UWORD            Stk3[STK_SIZE];
UWORD            Stk4[STK_SIZE];
UWORD            Stk5[STK_SIZE];

char             Data1[5] = "C";//definire date proprii task-urilor
char             Data2[5] = "P1|";
char             Data3[5] = "P2|";
char             Data4[5] = "P3|";
char             Data5[5] = "P4|";

void far         Task_Afis(void *data); //definire task-uri
void far         Task1(void *data);
void far         Task2(void *data);
void far         Task3(void *data);
void far         Task4(void *data);

void interrupt (*OldTickISR)(void);

int i=1;		//contor de cuante
int j=0;		//contor de autosuspendare task 3

void main(void)
{
    UBYTE err;


    clrscr();
    //salveaza vechiul vector de intrerupere (nivelul 0x08)
    //intreruperi ceas de timp real 18ms
    OldTickISR = getvect(0x08);
    //seteaza intreruperea software UCOS=0xF1 pentru comutarea contextului
    setvect(UCOS, (void interrupt (*)(void))OSCtxSw);
    setvect(0xF2, OldTickISR);
    //seteaza intreruperea software 0xF2 pentru executia rutinei
    //vechi de pe nivelul 0x08
    //initializeaza (creaza) un task fals (idle)
    OSInit(&OSIdleTaskStk[STK_SIZE], OS_MAX_TASKS);
    //creaza task-urile
    OSTaskCreate(Task_Afis, (void *)&Data1, (void *)&Stk1[STK_SIZE], 1);
    OSTaskCreate(Task1, (void *)&Data2, (void *)&Stk2[STK_SIZE], 2);
    OSTaskCreate(Task2, (void *)&Data3, (void *)&Stk3[STK_SIZE], 3);
    OSTaskCreate(Task3, (void *)&Data4, (void *)&Stk4[STK_SIZE], 4);
    OSTaskCreate(Task4, (void *)&Data5, (void *)&Stk5[STK_SIZE], 5);

    //start executie
    OSStart();
}

void far Task_Afis(void *data)
{
    setvect(0x08, (void interrupt (*)(void))OSTickISR);
    while (1) {
	OSTimeDly(18);//nu se va modifica : afisare la o secunda
	printf("\n");
	printf("%s",data);
	printf("%d:|",i);
	i++;	//nr. cuantei
	if(kbhit()){
	switch(getch()){
	case 'x':
	case 'X':
	    {
	    setvect(0x08, OldTickISR);
	    exit(0);
	    break;
	    }
	}
	}
    }
}
//planificarea proceselor in cuante = multiplii de 18 (in secunde)

void far Task1(void *data)
{
    while (1) {
	OSTimeDly(18);		//1 sec
	printf("%s",data);
	      }
}

void far Task2(void *data)
{
    while (1) {
	OSTimeDly(36);		//2 sec
	printf("%s",data);
	       }
}

void far Task3(void *data)
{
    while (1) {
	OSTimeDly(54);		//3 sec
	printf("%s",data);
	j++;
	if(j==nr_c) OSTaskDelete();
	      }
}

void far Task4(void *data)
{
    while (1) {
	OSTimeDly(72);		//4 sec
	printf("%s",data);
	      }
}
