/*
************************************************************
*                         TEST21.C
*                      uCOS EXAMPLE
************************************************************
*/

#include    <STDIO.H>
#include    <STRING.H>
#include    <CTYPE.H>
#include    <STDLIB.H>
#include    <CONIO.H>
#include    <DOS.H>
#include    "UCOS186C.H"
#include    "UCOS.H"
extern void interrupt (*OldTickISR)(void);


#define          OS_MAX_TASKS    10    //numar maxim de task-uri
#define          STK_SIZE      1024    //dimensiunea stivei
#define          Q_SIZE          10    //dimensiunea cozii de nesaje

OS_TCB           OSTCBTbl[OS_MAX_TASKS];//tabela de task-uri
UWORD            OSIdleTaskStk[STK_SIZE];//task fals

UWORD            KeyStk[STK_SIZE]; //stive asociate task-urilor
UWORD            DispStk[STK_SIZE];
UWORD            Task1Stk[STK_SIZE];
UWORD            Task2Stk[STK_SIZE];
UWORD            Task3Stk[STK_SIZE];

OS_SEM           Sem;	//structura de semafor
OS_MBOX          Mbox;  //structura de cutie postala
OS_Q             Q;     //structura de coada de mesaje

void            *QData[Q_SIZE]; //coada de mesaje

UWORD            Ctr1 = 0;        //structura de date protejata
UWORD            Ctr2 = 0;        //prin semafoare
UBYTE            Min  = 0;
UBYTE            Sec  = 0;

void far         KeyTask(void *data);    //definirea task-urilor
void far         DispTask(void *data);
void far         Task1(void *data);
void far         Task2(void *data);
void far         Task3(void *data);

void interrupt (*OldTickISR)(void);     //rutina de intrerupere 18ms

char mesaj[80];        //variabile auxiliare
char mesaj1[20][80];

int cnt=0;
int cnt1=0;

void main(void)
{
    clrscr();
    //seteaza intreruperile (ca in exemplul A)
    OldTickISR = getvect(0x08);
    setvect(UCOS, (void interrupt (*)(void))OSCtxSw);
    setvect(0xF2, OldTickISR);
    //defineste (creaza) un task fals (idle)
    OSInit(&OSIdleTaskStk[STK_SIZE], OS_MAX_TASKS);
    //initializeaza semaforul
    OSSemInit(&Sem, 1);
    //initializeaza cutia postala
    OSMboxInit(&Mbox, (void *)0);
    //initializeaza coada de mesaje
    OSQInit(&Q, &QData[0], Q_SIZE);
    //creaza task-urile
    OSTaskCreate(DispTask, (void *)0, (void *)&DispStk[STK_SIZE],   0);
    OSTaskCreate(KeyTask,  (void *)0, (void *)&KeyStk[STK_SIZE],    1);
    OSTaskCreate(Task1,    (void *)0, (void *)&Task1Stk[STK_SIZE], 10);
    OSTaskCreate(Task2,    (void *)0, (void *)&Task2Stk[STK_SIZE], 20);
    OSTaskCreate(Task3,    (void *)0, (void *)&Task3Stk[STK_SIZE], 30);
    //start executie
    OSStart();
}

void far KeyTask(void *data)
{
    UBYTE i;

    setvect(0x08, (void interrupt (*)(void))OSTickISR);
    while (1) {
	OSTimeDly(1);
	if (kbhit()) {
	    switch (getch()) {
		case '1': cnt++;
			  sprintf(mesaj,"Mesaj in cutia postala [%d] ",cnt);
			  OSMboxPost(&Mbox, (void *)mesaj);
			  break;
		case '2': cnt1++;
			  sprintf(mesaj1[cnt1],"Mesaj in coada [%d]",cnt1);
			  OSQPost(&Q, (void *)mesaj1[cnt1]);
			  break;
		case 'x':
		case 'X': setvect(0x08, OldTickISR);
			  exit(0);
			  break;
	    }
	}
    }
}


void far Task1(void *data)
{
    UBYTE err;
    void* m;

    while (1) {
	m=OSMboxPend(&Mbox, 36, &err);
	gotoxy(1,1);
	if (m!=NULL) printf("%s\n",(char*)m);
	OSSemPend(&Sem, 0);
	Ctr1++;
	gotoxy(1, 13);
	printf("Ctr1-task1  =  %4d", Ctr1);
	OSSemPost(&Sem);
    }
}


void far Task2(void *data)
{
    UBYTE err;
    void *m;
    int k;
    k=1;

    while (1) {
	m=OSQPend(&Q, 72, &err);
	gotoxy(50,k);
	if (m!=NULL) {printf("%s\n",(char*)m);k++;if(k==11) k=1;}
	OSSemPend(&Sem, 0);
	Ctr2++;
	gotoxy(1, 14);
	printf("Ctr2-task1  =  %4d", Ctr2);
	OSSemPost(&Sem);
    }
}


void far Task3(void *data)
{
    while (1) {
	OSTimeDly(18);
	OSSemPend(&Sem, 0);
	Sec++;
	if (Sec > 59) {
	    Sec = 0;
	    Min++;
	}
	gotoxy(1, 15);
	printf("Min:Sec -task3  =  %02d:%02d", Min,Sec);
	OSSemPost(&Sem);
    }
}


void far DispTask(void *data)
{
    UWORD ctr1, ctr2;
    UBYTE min,  sec;


    while (1) {
	OSTimeDly(6);

	OSSemPend(&Sem, 0);
	ctr1 = Ctr1;
	ctr2 = Ctr2;
	min  = Min;
	sec  = Sec;
	OSSemPost(&Sem);
	gotoxy(1, 9);
	printf("Clock = %02d:%02d", min, sec);
	gotoxy(1, 10);
	printf("Ctr1  =  %4d", ctr1);
	gotoxy(1, 11);
	printf("Ctr2  =  %4d", ctr2);
    }
}
